function varargout = update(varargin)

persistent plot_handle

%create a run time object that can return the value of the outport block's
%input and then put the value in a string
rto1 = get_param('CAN_Communication/Out1','RuntimeObject');
%rto2 = get_param('CAN_Communication/CAN Unpack Subsystem/Out2','RuntimeObject');
%rto3 = get_param('CAN_Communication/CAN Unpack Subsystem/Out3','RuntimeObject');


% get Data from Simulation
rto1_Data = rto1.InputPort(1).Data;
XData1 = get_param('CAN_Communication','SimulationTime');
YData1 = rto1_Data(1);
XData2 = get_param('CAN_Communication','SimulationTime');
YData2 = rto1_Data(2);
XData3 = get_param('CAN_Communication','SimulationTime');
YData3 = rto1_Data(3);

str = num2str(YData1);
edit = findobj('Tag','edit_value');
set(edit,'string',str);

% save Data to workspace
assignin('base','XData1',XData1)
assignin('base','YData1',YData1)
assignin('base','XData2',XData2)
assignin('base','YData2',YData2)
assignin('base','XData3',XData3)
assignin('base','YData3',YData3)

if isempty(plot_handle) || any(~ishandle(plot_handle))
    guiplot=findobj(0, 'Tag', 'axes_can');
    plot_handle = plot(guiplot,XData1,YData1,XData2,YData2,XData3,YData3);
else
    XData_old1 = get(plot_handle(1), 'XData');
    YData_old1 = get(plot_handle(1), 'YData');
    XData1 = [XData_old1, XData1];
    YData1 = [YData_old1, YData1];
    XData_old2 = get(plot_handle(2), 'XData');
    YData_old2 = get(plot_handle(2), 'YData');
    XData2 = [XData_old2, XData2];
    YData2 = [YData_old2, YData2];
    XData_old3 = get(plot_handle(3), 'XData');
    YData_old3 = get(plot_handle(3), 'YData');
    XData3 = [XData_old3, XData3];
    YData3 = [YData_old3, YData3]; 
    set(plot_handle(1), 'XData', XData1, 'YData', YData1,'Color','blue');
    set(plot_handle(2), 'XData', XData2, 'YData', YData2,'Color','red');
    set(plot_handle(3), 'XData', XData3, 'YData', YData3,'Color','green');
    drawnow
    grid on
    hold on
end
    